//
// © 2005-2008 Marko Lindqvist
//

#ifndef H_SDKS_CELL
#define H_SDKS_CELL

#include <string>

#include "sdksui.h"

enum remove_result { RR_KNOWN, RR_ADVANCE, RR_SOLVED };

class sudoku;

class cell
{
 public:
  cell(sudoku *parent_in);
  ~cell();
  void print(std::string unknown, std::string illegal, sdks_ui *ui, int size);
  bool set_result(int result_in, const char *reason);
  remove_result remove_possibility(int removed, const char *reason);
  int solved();
  bool is_possible(int result_in);
  void setxy(int x_in, int y_in);
  int get_x();
  int get_y();
 private:
  cell(); // Prevent use of default constructor
  int result;
  int possibility_count;
  bool *possibilities;
  int x;
  int y;
  sudoku *parent;
};


#endif // H_SSKS_CELL
