//
// © 2005-2008 Marko Lindqvist
//

#include "sdksoption.h"

static struct {
  bool explain;      // Explain solution
  bool intermediate; // Display intermediate solutions
  bool quiet;        // Disable default messages
  bool solvetime;    // Display time spent on solving
  bool http;         // Communicate via http-protocol
} options;


void init_options()
{
  options.explain = false;
  options.intermediate = false;
  options.quiet = false;
  options.solvetime = false;
  options.http = false;
}

void set_option(sdks_option option, bool enabled)
{
  switch(option) {
   case OPTION_EXPLAIN:
     options.explain = enabled;
     break;
   case OPTION_INTERMED:
     options.intermediate = enabled;
     break;
   case OPTION_QUIET:
     options.quiet = enabled;
     break;
   case OPTION_SOLVETIME:
     options.solvetime = enabled;
     break;
  case OPTION_HTTP:
    options.http = enabled;
    break;
  }
}


bool get_option(sdks_option option)
{
  switch(option) {
   case OPTION_EXPLAIN:
     return options.explain;
   case OPTION_INTERMED:
     return options.intermediate;
   case OPTION_QUIET:
     return options.quiet;
   case OPTION_SOLVETIME:
     return options.solvetime;
   case OPTION_HTTP:
    return options.http;
  }

  return false;
}
