//
// © 2005-2008 Marko Lindqvist
//

#ifndef H_SDKS_UI
#define H_SDKS_UI

#include <string>

class cell;
class sudoku;
class sdks_input;

class sdks_ui
{
 public:
  virtual ~sdks_ui();

  virtual void solve_log(cell *pcell, const char *msg);
  virtual void print_sudoku(sudoku *puzzle);
  virtual void print_sudoku_possibilities(sudoku *puzzle);
  virtual void print_method_name(const char *mname);
  virtual void start_output();
  virtual void finish_output();
  virtual void print_header(std::string msg, int size);
  virtual void print_msg(std::string msg);

  virtual sdks_input *get_input(int origbase);

  int char_to_int(char c, int size);
  char int_to_char(int n, int size);
 private:
  void print_possibility_ruler(int size);
  void print_possibility_verticals(int size);
};

#endif // H_SDKS_UI
